## -*- coding: utf-8; mode: python; -*-
# -*- coding: utf-8; -*-
<%text>################################################################################</%text>
#
#  Rattail -- Retail Software Framework
#  Copyright © 2010-${year} Lance Edgar
#
#  This file is part of Rattail.
#
#  Rattail is free software: you can redistribute it and/or modify it under the
#  terms of the GNU General Public License as published by the Free Software
#  Foundation, either version 3 of the License, or (at your option) any later
#  version.
#
#  Rattail is distributed in the hope that it will be useful, but WITHOUT ANY
#  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
#  details.
#
#  You should have received a copy of the GNU General Public License along with
#  Rattail.  If not, see <http://www.gnu.org/licenses/>.
#
<%text>################################################################################</%text>
"""
Customer data model extensions
"""

import sqlalchemy as sa
from sqlalchemy import orm

from rattail.db import model


class ${integration_studly}Customer(model.Base):
    """
    ${integration_name} extensions to core Customer model
    """
    __tablename__ = '${integration_prefix}_customer'
    __table_args__ = (
        sa.ForeignKeyConstraint(['uuid'], ['customer.uuid'], name='${integration_prefix}_customer_fk_customer'),
    )

    uuid = model.uuid_column(default=None)

    customer = orm.relationship(
        model.Customer,
        doc="""
        Customer to which this extension record pertains.
        """,
        backref=orm.backref(
            '_${integration_prefix}',
            uselist=False,
            cascade='all, delete-orphan',
            doc="""
            ${integration_name} extension record for the customer.
            """),
    )

    # favorite_color = sa.Column(sa.String(length=50), nullable=True, doc="""
    # Customer's favorite color.
    # """)
